/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-19 at 02:47:05 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.cloudbuild.v1.model;

/**
 * Metadata for build operations.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud Build API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BuildOperationMetadata extends com.google.api.client.json.GenericJson {

  /**
   * The build that the operation is tracking.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Build build;

  /**
   * The build that the operation is tracking.
   * @return value or {@code null} for none
   */
  public Build getBuild() {
    return build;
  }

  /**
   * The build that the operation is tracking.
   * @param build build or {@code null} for none
   */
  public BuildOperationMetadata setBuild(Build build) {
    this.build = build;
    return this;
  }

  @Override
  public BuildOperationMetadata set(String fieldName, Object value) {
    return (BuildOperationMetadata) super.set(fieldName, value);
  }

  @Override
  public BuildOperationMetadata clone() {
    return (BuildOperationMetadata) super.clone();
  }

}
