/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-19 at 02:47:05 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.cloudbuild.v1.model;

/**
 * An image built by the pipeline.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud Build API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BuiltImage extends com.google.api.client.json.GenericJson {

  /**
   * Docker Registry 2.0 digest.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String digest;

  /**
   * Name used to push the container image to Google Container Registry, as presented to `docker
   * push`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Output only. Stores timing information for pushing the specified image.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private TimeSpan pushTiming;

  /**
   * Docker Registry 2.0 digest.
   * @return value or {@code null} for none
   */
  public java.lang.String getDigest() {
    return digest;
  }

  /**
   * Docker Registry 2.0 digest.
   * @param digest digest or {@code null} for none
   */
  public BuiltImage setDigest(java.lang.String digest) {
    this.digest = digest;
    return this;
  }

  /**
   * Name used to push the container image to Google Container Registry, as presented to `docker
   * push`.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Name used to push the container image to Google Container Registry, as presented to `docker
   * push`.
   * @param name name or {@code null} for none
   */
  public BuiltImage setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Output only. Stores timing information for pushing the specified image.
   * @return value or {@code null} for none
   */
  public TimeSpan getPushTiming() {
    return pushTiming;
  }

  /**
   * Output only. Stores timing information for pushing the specified image.
   * @param pushTiming pushTiming or {@code null} for none
   */
  public BuiltImage setPushTiming(TimeSpan pushTiming) {
    this.pushTiming = pushTiming;
    return this;
  }

  @Override
  public BuiltImage set(String fieldName, Object value) {
    return (BuiltImage) super.set(fieldName, value);
  }

  @Override
  public BuiltImage clone() {
    return (BuiltImage) super.clone();
  }

}
