/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-19 at 02:47:05 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.cloudbuild.v1.model;

/**
 * Push contains filter properties for matching GitHub git pushes.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud Build API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class PushFilter extends com.google.api.client.json.GenericJson {

  /**
   * Regexes matching branches to build.
   *
   * The syntax of the regular expressions accepted is the syntax accepted by RE2 and described at
   * https://github.com/google/re2/wiki/Syntax
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String branch;

  /**
   * When true, only trigger a build if the revision regex does NOT match the git_ref regex.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean invertRegex;

  /**
   * Regexes matching tags to build.
   *
   * The syntax of the regular expressions accepted is the syntax accepted by RE2 and described at
   * https://github.com/google/re2/wiki/Syntax
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String tag;

  /**
   * Regexes matching branches to build.
   *
   * The syntax of the regular expressions accepted is the syntax accepted by RE2 and described at
   * https://github.com/google/re2/wiki/Syntax
   * @return value or {@code null} for none
   */
  public java.lang.String getBranch() {
    return branch;
  }

  /**
   * Regexes matching branches to build.
   *
   * The syntax of the regular expressions accepted is the syntax accepted by RE2 and described at
   * https://github.com/google/re2/wiki/Syntax
   * @param branch branch or {@code null} for none
   */
  public PushFilter setBranch(java.lang.String branch) {
    this.branch = branch;
    return this;
  }

  /**
   * When true, only trigger a build if the revision regex does NOT match the git_ref regex.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getInvertRegex() {
    return invertRegex;
  }

  /**
   * When true, only trigger a build if the revision regex does NOT match the git_ref regex.
   * @param invertRegex invertRegex or {@code null} for none
   */
  public PushFilter setInvertRegex(java.lang.Boolean invertRegex) {
    this.invertRegex = invertRegex;
    return this;
  }

  /**
   * Regexes matching tags to build.
   *
   * The syntax of the regular expressions accepted is the syntax accepted by RE2 and described at
   * https://github.com/google/re2/wiki/Syntax
   * @return value or {@code null} for none
   */
  public java.lang.String getTag() {
    return tag;
  }

  /**
   * Regexes matching tags to build.
   *
   * The syntax of the regular expressions accepted is the syntax accepted by RE2 and described at
   * https://github.com/google/re2/wiki/Syntax
   * @param tag tag or {@code null} for none
   */
  public PushFilter setTag(java.lang.String tag) {
    this.tag = tag;
    return this;
  }

  @Override
  public PushFilter set(String fieldName, Object value) {
    return (PushFilter) super.set(fieldName, value);
  }

  @Override
  public PushFilter clone() {
    return (PushFilter) super.clone();
  }

}
